package enum

type NursingHomeUserWithDayKind int32

const (
	NursingHomeUserWithDayKindForBreakfast = 1
	NursingHomeUserWithDayKindForLunch     = 2
	NursingHomeUserWithDayKindForDinner    = 3
)

func (gt NursingHomeUserWithDayKind) String() string {
	switch gt {
	case NursingHomeUserWithDayKindForBreakfast:
		return "早餐"
	case NursingHomeUserWithDayKindForLunch:
		return "午餐"
	case NursingHomeUserWithDayKindForDinner:
		return "晚餐"
	default:
		return "未知"
	}
}

type NursingHomeUserWithDayState int32

const (
	NursingHomeUserWithDayStateForWait      = 1
	NursingHomeUserWithDayStateForAlready   = 2
	NursingHomeUserWithDayStateForCanceling = 3
	NursingHomeUserWithDayStateForCancel    = 4
)

func (gt NursingHomeUserWithDayState) String() string {
	switch gt {
	case NursingHomeUserWithDayStateForWait:
		return "待就餐"
	case NursingHomeUserWithDayStateForAlready:
		return "已就餐"
	case NursingHomeUserWithDayStateForCanceling:
		return "退款中"
	case NursingHomeUserWithDayStateForCancel:
		return "已退款"
	default:
		return "未知"
	}
}
